diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/core/m_nick.c PleXusIRCd-1.17a/modules/core/m_nick.c
--- ircd-hybrid-7.0/modules/core/m_nick.c	Wed Apr  2 20:29:02 2003
+++ PleXusIRCd-1.17a/modules/core/m_nick.c	Wed Aug 20 19:53:38 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_nick.c,v 1.100.2.2 2003/04/03 01:29:02 lusky Exp $
+ *  $Id: m_nick.c,v 1.100.2.3 2003/08/18 01:29:02 static Exp $
  */
 
 #include "stdinc.h"
@@ -78,7 +78,7 @@
 };
 
 struct Message client_msgtab = {
-  "CLIENT", 0, 0, 10, 0, MFLG_SLOW, 0,
+  "CLIENT", 0, 0, 11, 0, MFLG_SLOW, 0,
   {m_ignore, m_ignore, ms_client, m_ignore}
 };
 
@@ -97,7 +97,7 @@
   mod_del_cmd(&client_msgtab);
 }
 
-const char *_version = "$Revision: 1.100.2.2 $";
+const char *_version = "$Revision: 1.100.2.3 $";
 #endif
 
 /*
@@ -314,8 +314,10 @@
  *    parv[4] = umode
  *    parv[5] = username
  *    parv[6] = hostname
- *    parv[7] = server
- *    parv[8] = ircname
+ *    parv[7] = vhost
+ *    parv[8] = server
+ *    parv[9] = svsid
+ *    parv[10] = ircname
  */
 static void
 ms_nick(struct Client *client_p, struct Client *source_p,
@@ -332,8 +334,8 @@
     return;
   }
 
-  /* parc == 3 on nickchange, parc == 9 on new nick */
-  if((IsClient(source_p) && (parc != 3)) || (IsServer(source_p) && (parc != 9)))
+  /* parc == 3 on nickchange, parc == 11 on new nick */
+  if((IsClient(source_p) && (parc != 3)) || (IsServer(source_p) && (parc != 11)))
   {
     char tbuf[BUFSIZE] = { 0 };
     int j;
@@ -358,21 +360,21 @@
   strlcpy(nick, parv[1], NICKLEN);
 
   if(check_clean_nick(client_p, source_p, nick, parv[1],
-                      (parc == 9 ? parv[7] : (char *) source_p->user->server)))
+                      (parc == 11 ? parv[8] : (char *) source_p->user->server)))
     return;
 
-  if (parc == 9)
+  if (parc == 11)
     {
-      if (check_clean_user(client_p, nick, parv[5], parv[7]) ||
-          check_clean_host(client_p, nick, parv[6], parv[7]))
+      if (check_clean_user(client_p, nick, parv[5], parv[8]) ||
+          check_clean_host(client_p, nick, parv[6], parv[8]))
         return;
 
       /* check the length of the clients gecos */
-      if(strlen(parv[8]) > REALLEN)
+      if(strlen(parv[10]) > REALLEN)
         {
           sendto_realops_flags(FLAGS_ALL, L_ALL, "Long realname from server %s for %s",
-                         parv[7], parv[1]);
-          parv[8][REALLEN] = '\0';
+                         parv[8], parv[1]);
+          parv[10][REALLEN] = '\0';
         }
 
       if (IsServer(source_p))
@@ -431,8 +433,8 @@
   char    *id;
   char    *name;
 
-  id = parv[8];
-  name = parv[9];
+  id = parv[9];
+  name = parv[10];
 
   /* XXX can this happen ? */
   if (BadPtr(parv[1]))
@@ -442,9 +444,9 @@
   strlcpy(nick, parv[1], NICKLEN);
 
   /* check the nicknames, usernames and hostnames are ok */
-  if(check_clean_nick(client_p, source_p, nick, parv[1], parv[7]) ||
-     check_clean_user(client_p, nick, parv[5], parv[7]) ||
-     check_clean_host(client_p, nick, parv[6], parv[7]))
+  if(check_clean_nick(client_p, source_p, nick, parv[1], parv[8]) ||
+     check_clean_user(client_p, nick, parv[5], parv[8]) ||
+     check_clean_host(client_p, nick, parv[6], parv[8]))
     return;
 
   /* check length of clients gecos */
@@ -715,6 +717,7 @@
     /* copy the nick in place */
     (void)strcpy(source_p->name, nick);
     (void)add_to_client_hash_table(nick, source_p);
+    strncpy(source_p->vhost, parv[6], HOSTLEN+1);
 
     if (parc > 8)
     {
@@ -731,12 +734,22 @@
 	 if(!(source_p->umodes & FLAGS_OPER) && (flag & FLAGS_OPER))
 	   Count.oper++;
 
+	 if(!(source_p->umodes & FLAGS_HIDDEN) && (flag & FLAGS_HIDDEN)) {  
+                if (parv[7][0] != '*')
+                        strncpy(source_p->vhost, parv[7], HOSTLEN +1);
+                else {
+                        /* THIS SHOULD NEVER HAPPEN */
+                        sendto_realops_flags(FLAGS_DEBUG, L_ALL, "Warning, Server %s sent a Invalid Vhost in nick_from_server", source_p->from->name);
+                        strncpy(source_p->vhost, source_p->host, HOSTLEN +1);
+                }
+         }
+
 	 source_p->umodes |= flag & SEND_UMODES;
 	 m++;
       }
 
       return do_remote_user(nick, client_p, source_p, parv[5], parv[6],
-                            parv[7], parv[8], NULL);
+                            parv[8], parv[10], NULL, atol(parv[9]));
     }
   }
   else if(source_p->name[0])
@@ -745,9 +758,9 @@
     if(irccmp(parv[0], nick))
       source_p->tsinfo = newts ? newts : CurrentTime;
 
-    sendto_common_channels_local(source_p, 1,
+    sendto_common_channels_local(source_p,
                                  ":%s!%s@%s NICK :%s",
-                                 source_p->name,source_p->username,source_p->host,
+                                 source_p->name,source_p->username,source_p->vhost,
                                  nick);
 
     if (source_p->user)
@@ -785,8 +798,8 @@
   int flag;
   char *m;
 
-  id = parv[8];
-  name = parv[9];
+  id = parv[9];
+  name = parv[11];
 
   source_p = make_client(client_p);
   add_client_to_list(source_p);
@@ -802,6 +815,7 @@
   (void)strcpy(source_p->name, nick);
   (void)add_to_client_hash_table(nick, source_p);
   add_to_id_hash_table(id, source_p);
+  strncpy(source_p->vhost, parv[6], HOSTLEN+1);
 
   /* parse usermodes */
   m = &parv[4][1];
@@ -813,13 +827,22 @@
     if(flag & FLAGS_OPER)
       Count.oper++;
 
+    if(!(source_p->umodes & FLAGS_HIDDEN) && (flag & FLAGS_HIDDEN)) {
+                if (parv[7][0] != '*')
+                        strncpy(source_p->vhost, parv[7], HOSTLEN +1);
+                else {
+                        sendto_realops_flags(FLAGS_DEBUG, L_ALL, "Warning %s sent a Invalid Hidden Host command in client_from_serv_server", source_p->from->name);
+                        strncpy(source_p->vhost, source_p->host, HOSTLEN +1);
+                }
+         }
+
     source_p->umodes |= flag & SEND_UMODES;
     m++;
 
   }
 
   return do_remote_user(nick, client_p, source_p, parv[5], parv[6],
-                        parv[7], name, id);
+                        parv[8], name, id, atol(parv[10]));
 }			
   
 static int 
@@ -898,9 +921,9 @@
         SetKilled(target_p);
 	exit_client(client_p, target_p, &me, "Nick collision");
 	
-	if(parc == 9)
+	if(parc == 11)
 	  nick_from_server(client_p,source_p,parc,parv,newts,nick);
-	else if(parc == 10)
+	else if(parc == 12)
 	  client_from_server(client_p,source_p,parc,parv,newts,nick);
 	  
 	return 0;
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/core/m_part.c PleXusIRCd-1.17a/modules/core/m_part.c
--- ircd-hybrid-7.0/modules/core/m_part.c	Thu Feb  6 03:46:06 2003
+++ PleXusIRCd-1.17a/modules/core/m_part.c	Thu Jul 24 08:34:46 2003
@@ -165,7 +165,7 @@
    */
   if (reason[0] &&
       (is_any_op(chptr, source_p) || !MyConnect(source_p) ||
-       ((can_send(chptr, source_p) > 0 && 
+       ((can_send(chptr, source_p, NULL) > 0 && 
          (source_p->firsttime + ConfigFileEntry.anti_spam_exit_message_time)
          < CurrentTime))))
   {
@@ -179,7 +179,7 @@
                          chptr, ":%s!%s@%s PART %s :%s",
                          source_p->name,
                          source_p->username,
-                         source_p->host,
+                         source_p->vhost,
                          bchan->chname,
                          reason);
   }
@@ -193,7 +193,7 @@
                          chptr, ":%s!%s@%s PART %s",
                          source_p->name,
                          source_p->username,
-                         source_p->host,
+                         source_p->vhost,
                          bchan->chname);
   }
   remove_user_from_channel(chptr, source_p);
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/core/m_sjoin.c PleXusIRCd-1.17a/modules/core/m_sjoin.c
--- ircd-hybrid-7.0/modules/core/m_sjoin.c	Thu Jul  4 12:07:23 2002
+++ PleXusIRCd-1.17a/modules/core/m_sjoin.c	Wed Aug 20 23:19:06 2003
@@ -178,6 +178,18 @@
       case 't':
         mode.mode |= MODE_TOPICLIMIT;
         break;
+      case 'Z':
+	mode.mode |= MODE_BW;
+	break;
+      case 'c':
+	mode.mode |= MODE_NOCOLOUR;
+	break;
+      case 'R':
+	mode.mode |= MODE_REGONLY;
+	break;
+      case 'O':
+	mode.mode |= MODE_OPERONLY;
+	break;
 #ifdef ANONOPS
       case 'a':
 	if(ConfigChannel.use_anonops)
@@ -579,7 +591,7 @@
 	      sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
 				   target_p->name,
 				   target_p->username,
-				   target_p->host,
+				   target_p->vhost,
 				   top_chptr->chname);
 	    }
 	  else
@@ -588,7 +600,7 @@
 	      sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
 				   target_p->name,
 				   target_p->username,
-				   target_p->host,
+				   target_p->vhost,
 				   parv[2]);
 	    }
 	}
@@ -737,6 +749,10 @@
   { MODE_MODERATED,  'm' },
   { MODE_INVITEONLY, 'i' },
   { MODE_PRIVATE,    'p' },
+  { MODE_BW, 	     'Z' },
+  { MODE_NOCOLOUR,   'c' },
+  { MODE_REGONLY,    'R' },
+  { MODE_OPERONLY,   'O' },
 #ifdef ANONOPS
   { MODE_HIDEOPS,    'a' },
 #endif
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/core/m_squit.c PleXusIRCd-1.17a/modules/core/m_squit.c
--- ircd-hybrid-7.0/modules/core/m_squit.c	Fri Feb 14 18:01:53 2003
+++ PleXusIRCd-1.17a/modules/core/m_squit.c	Thu Jul 24 19:52:34 2003
@@ -100,6 +100,11 @@
     {
       if(MyConnect(found_squit->target_p))
 	{
+	  if (strcmp(SERVICES,found_squit->target_p->name) == 0) {
+                sendto_realops_flags(FLAGS_ALL, L_ALL, "Attempted SQUIT of services from %s (%s)",
+                                        get_client_name(source_p, HIDE_IP), comment);
+                return;   
+          }
 	  sendto_realops_flags(FLAGS_ALL, L_ALL,
 			       "Received SQUIT %s from %s (%s)",
 			       found_squit->target_p->name,
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_force.c PleXusIRCd-1.17a/modules/m_force.c
--- ircd-hybrid-7.0/modules/m_force.c	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/modules/m_force.c	Tue Aug 19 01:52:08 2003
@@ -0,0 +1,314 @@
+/* contrib/m_force.c
+ * Copyright (C) 2002 Hybrid Development Team
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $Id: m_force.c,v 1.17 2002/11/01 13:24:41 db Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"     /* FALSE bleah */
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "hash.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "channel.h"
+#include "channel_mode.h"
+
+
+static void mo_forcejoin(struct Client *client_p, struct Client *source_p,
+                         int parc, char *parv[]);
+static void mo_forcepart(struct Client *client_p, struct Client *source_p,
+		         int parc, char *parv[]);
+
+struct Message forcejoin_msgtab = {
+  "SAJOIN", 0, 0, 3, 0, MFLG_SLOW, 0,
+  {m_ignore, m_not_oper, mo_forcejoin, m_ignore}
+};
+struct Message forcepart_msgtab = {
+  "SAPART", 0, 0, 3, 0, MFLG_SLOW, 0,
+  {m_ignore, m_not_oper, mo_forcepart, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&forcejoin_msgtab);
+  mod_add_cmd(&forcepart_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&forcejoin_msgtab);
+  mod_del_cmd(&forcepart_msgtab);
+}
+
+char *_version = "$Revision: 1.17 $";
+#endif
+
+/*
+ * m_forcejoin
+ *      parv[0] = sender prefix
+ *      parv[1] = user to force
+ *      parv[2] = channel to force them into
+ */
+static void mo_forcejoin(struct Client *client_p, struct Client *source_p,
+                         int parc, char *parv[])
+{
+  struct Client *target_p;
+  struct Channel *chptr;
+  int type;
+  char mode;
+  char sjmode;
+  char *newch;
+
+  if(!IsAdmin(source_p) && !IsServer(source_p))
+  {
+    sendto_one(source_p, ":%s NOTICE %s :You have no A flag", me.name, parv[0]);
+    return;
+  }
+
+  /* if target_p is not existent, print message
+   * to source_p and bail - scuzzy
+   */
+  if ((target_p = find_client(parv[1])) == NULL)
+  {
+    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name,
+	       source_p->name, parv[1]);
+    return;
+  }
+
+  if (!MyConnect(target_p))
+  {
+    sendto_one(target_p, ":%s SAJOIN %s %s", parv[0], parv[1], parv[2]);
+    return;
+  }
+
+  /* select our modes from parv[2] if they exist... (chanop)*/
+  if(*parv[2] == '@')
+  {
+    type = CHFL_CHANOP;
+    mode = 'o';
+    sjmode = '@';
+  }
+#ifdef HALFOPS
+  else if(*parv[2] == '%')
+  {
+    type = CHFL_HALFOP;
+    mode = 'h';
+    sjmode = '%';
+  }
+#endif
+  else if(*parv[2] == '+')
+  {
+    type = CHFL_VOICE;
+    mode = 'v';
+    sjmode = '+';
+  }
+  else
+  {
+    type = CHFL_PEON;
+    mode = sjmode = '\0';
+  }
+    
+  if(mode != '\0')
+    parv[2]++;
+    
+  if((chptr = hash_find_channel(parv[2])) != NULL)
+    {
+      if(IsMember(target_p, chptr))
+      {
+        /* debugging is fun... */
+        sendto_one(source_p, ":%s NOTICE %s :*** Notice -- %s is already in %s", me.name,
+		   source_p->name, target_p->name, chptr->chname);
+	return;
+      }
+
+      add_user_to_channel(chptr, target_p, type);
+
+      if (chptr->chname[0] != '&')
+        sendto_server(target_p, target_p, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+	              ":%s SJOIN %lu %s + :%c%s",
+	              me.name, (unsigned long) chptr->channelts,
+	              chptr->chname, type ? sjmode : ' ', target_p->name);
+
+      sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+                             target_p->name, target_p->username,
+                             target_p->vhost, chptr->chname);
+
+      if(type)
+        sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +%c %s",
+	                     me.name, chptr->chname, mode, target_p->name);
+        
+      if(chptr->topic != NULL)
+      {
+	sendto_one(target_p, form_str(RPL_TOPIC), me.name,
+	           target_p->name, chptr->chname, chptr->topic);
+        sendto_one(target_p, form_str(RPL_TOPICWHOTIME),
+	           me.name, source_p->name, chptr->chname,
+	           chptr->topic_info, chptr->topic_time);
+      }
+
+      channel_member_names(target_p, chptr, chptr->chname, 1);
+    }
+  else
+    {
+      newch = parv[2];
+      if (!check_channel_name(newch))
+      {
+        sendto_one(source_p, form_str(ERR_BADCHANNAME), me.name,
+		   source_p->name, (unsigned char*)newch);
+	return;
+      }
+
+      /* channel name must begin with & or # */
+      if (!IsChannelName(newch))
+      {
+        sendto_one(source_p, form_str(ERR_BADCHANNAME), me.name,
+		   source_p->name, (unsigned char*)newch);
+        return;
+      }
+
+     /* it would be interesting here to allow an oper
+      * to force target_p into a channel that doesn't exist
+      * even more so, into a local channel when we disable
+      * local channels... but...
+      * I don't want to break anything - scuzzy
+      */
+      if (ConfigServerHide.disable_local_channels &&
+	  (*newch == '&'))
+      {
+        sendto_one(source_p, ":%s NOTICE %s :No such channel (%s)", me.name,
+		   source_p->name, newch);
+        return;
+      }
+
+      /* newch can't be longer than CHANNELLEN */
+      if (strlen(newch) > CHANNELLEN)
+      {
+	sendto_one(source_p, ":%s NOTICE %s :Channel name is too long", me.name,
+		   source_p->name);
+        return;
+      }
+
+      chptr = get_or_create_channel(target_p, newch, NULL);
+      add_user_to_channel(chptr, target_p, CHFL_CHANOP);
+
+      /* send out a join, make target_p join chptr */
+      if (chptr->chname[0] != '&')
+        sendto_server(target_p, target_p, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+                      ":%s SJOIN %lu %s +nt :@%s", me.name,
+		      (unsigned long) chptr->channelts, chptr->chname,
+		      target_p->name);
+
+      sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+                             target_p->name, target_p->username,
+                             target_p->vhost, chptr->chname);
+
+      chptr->mode.mode |= MODE_TOPICLIMIT;
+      chptr->mode.mode |= MODE_NOPRIVMSGS;
+
+      sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +nt", me.name,
+                           chptr->chname);
+
+      target_p->localClient->last_join_time = CurrentTime;
+      channel_member_names(target_p, chptr, chptr->chname, 1);
+
+      /* we do this to let the oper know that a channel was created, this will be
+       * seen from the server handling the command instead of the server that
+       * the oper is on.
+       */
+      sendto_one(source_p, ":%s NOTICE %s :*** Notice -- Creating channel %s", me.name,
+		 source_p->name, chptr->chname);
+    }
+}
+
+
+static void mo_forcepart(struct Client *client_p, struct Client *source_p,
+		         int parc, char *parv[])
+{
+  struct Client *target_p;
+  struct Channel *chptr;
+
+  if(!IsAdmin(source_p) && !IsServer(source_p))
+  {
+    sendto_one(source_p, ":%s NOTICE %s :You have no A flag", me.name, parv[0]);
+    return;
+  }
+
+  /* if target_p == NULL then let the oper know */
+  if ((target_p = find_client(parv[1])) == NULL)
+  {
+    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name,
+               source_p->name, parv[1]);
+    return;
+  }
+
+  if (!MyConnect(target_p))
+  {
+    sendto_one(target_p, ":%s SAPART %s %s", parv[0], parv[1], parv[2]);
+    return;
+  }
+
+  if((chptr = hash_find_channel(parv[2])) == NULL)
+  {
+    sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+               me.name, parv[0], parv[2]);
+    return;
+  }
+
+  if (!IsMember(target_p, chptr))
+  {
+    sendto_one(source_p, form_str(ERR_USERNOTINCHANNEL),
+               me.name, parv[0], parv[2], parv[1]);
+    return;
+  }
+  
+  if (chptr->chname[0] != '&')
+    sendto_server(target_p, target_p, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+		  ":%s PART %s :%s",
+		  target_p->name, chptr->chname,
+		  target_p->name);
+
+  sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s PART %s :%s",
+                       target_p->name, target_p->username,
+ 	               target_p->vhost,chptr->chname,
+		       target_p->name);
+  remove_user_from_channel(chptr, target_p);
+}
+
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_gline.c PleXusIRCd-1.17a/modules/m_gline.c
--- ircd-hybrid-7.0/modules/m_gline.c	Thu Apr 10 23:41:40 2003
+++ PleXusIRCd-1.17a/modules/m_gline.c	Fri Nov 28 05:30:49 2003
@@ -207,11 +207,11 @@
    */
   sendto_realops_flags(FLAGS_ALL, L_ALL,
                        "%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
-                       source_p->name, source_p->username, source_p->host,
+                       source_p->name, source_p->username, source_p->vhost,
                        me.name, user, host, reason);
   log_gline_request(source_p->name,
                     (const char *)source_p->username,
-                    source_p->host, me.name, user, host, reason);
+                    source_p->vhost, me.name, user, host, reason);
 
   /* If at least 3 opers agree this user should be G lined then do it */
   if (check_majority_gline(source_p, source_p->name,
